#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def gauss(f,a,b,n):
    h=(b-a)/(n+1)
    s=0
    r=np.sqrt(15)/10
    x=np.array([0.5-r,0.5,0.5+r])
    xk=a
    for k in range(n):
        s=s+h*(5*f(xk+h*x[0])+8*f(xk+h*x[1])+5*f(xk+h*x[2]))/18
        xk=xk+h
    return s


def simpson(f,a,b,n):
    h=(b-a)/(n+1)
    s=0
    x=np.array([0,0.5,1])
    xk=a
    for  k in range(n+1):
        s=s+h*(f(xk+h*x[0])+4*f(xk+h*x[1])+f(xk+h*x[2]))/6
        xk=xk+h
    return s


def exo1(x):
    return np.log(x)

def exo2(x):
    return np.exp(x)

itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=gauss(np.cos,-np.pi/2,np.pi/2,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-2)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
plt.plot(np.log(tabcompt),-np.log(tabcompt))
plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-3*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-4*np.log(tabcompt))
plt.title('Gauss: cos')
plt.show()


itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=simpson(np.cos,-np.pi/2,np.pi/2,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-2)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
#plt.plot(np.log(tabcompt),-np.log(tabcompt))
#plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-3*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-4*np.log(tabcompt))
plt.title('Simpson: cos')
plt.show()
    
    
########## Sinus: ############

itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=gauss(np.sin,0,np.pi,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-2)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
plt.plot(np.log(tabcompt),-np.log(tabcompt))
plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-3*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-4*np.log(tabcompt))
plt.title('Gauss: sin')
plt.show()


itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=simpson(np.sin,0,np.pi,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-2)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
#plt.plot(np.log(tabcompt),-np.log(tabcompt))
#plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-3*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-4*np.log(tabcompt))
plt.title('Simpson: sin')
plt.show()


########### Log: ###############

itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=gauss(np.log,1,np.e,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-1)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
plt.plot(np.log(tabcompt),-np.log(tabcompt))
plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-3*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-4*np.log(tabcompt))
plt.title('Gauss: log')
plt.show()


itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=simpson(np.log,1,np.e,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-1)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
#plt.plot(np.log(tabcompt),-np.log(tabcompt))
#plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-3*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-4*np.log(tabcompt))
plt.title('Simpson: log')
plt.show()

########### Exponentielle: ############

itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=gauss(np.exp,0,1,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-np.e+1)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
plt.plot(np.log(tabcompt),-np.log(tabcompt))
plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-3*np.log(tabcompt))
#plt.plot(np.log(tabcompt),-4*np.log(tabcompt))
plt.title('Gauss: exp')
plt.show()


itmax=50 # 10
tabI=np.zeros(itmax)
tabcompt=np.zeros(itmax)
taberr=np.zeros(itmax)



for k in range(itmax):
    I=simpson(np.exp,0,1,k+1)
    tabI[k]=I
    taberr[k]=np.abs(I-np.e+1)
    tabcompt[k]=k+1

plt.plot(np.log(tabcompt),np.log(taberr))
#plt.plot(np.log(tabcompt),-np.log(tabcompt))
#plt.plot(np.log(tabcompt),-2*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-3*np.log(tabcompt))
plt.plot(np.log(tabcompt),np.log(taberr)[0]-4*np.log(tabcompt))
plt.title('Simpson: exp')
plt.show()
    
    
    
    
    
    
    
   
    
    