#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def point_milieu_(f,a,b,n):
    h=(b-a)/(n+1)
    s=0
    for k in range(n):
        s=s+h*f(a+h*(k+0.5))
    return s

def point_milieu(f,a,b,n):
    h=(b-a)/(n+1)
    s=0
    xk=a
    for k in range(n):
        s=s+h*f(xk+h/2) 
        xk=xk+h
    return s


def exo3(x):
    return np.exp(np.sin(x))/x**(8/9)

def exo4(x):
    return np.exp(np.sin(x))

def mixte_(f,a,b,n,h):
    pas=(b-a-h)/(n+1)
    s=9*h**(1/9)*f(h/10)
    for k in range(n):
        s=s+h*f(a+h+h*(k+0.5))
    return s

def ecart(f,h):
    return 9*h**(1/9)*f(h/10)

def mixte(f,h,n):
    return ecart(f,h)+point_milieu(f,h,1,n)

I=point_milieu(np.cos,0,np.pi/2,100)
print(I)


I=point_milieu(exo3,0.1,1,1000)
print(I)

tab_I=np.zeros(10)
for k in range(10):
    tab_I[k]=point_milieu(exo3,0.01,1,100*k+10)
    
plt.plot(tab_I)
plt.show()


x=0.01*np.arange(101)
y=np.zeros(len(x))
tab_I=np.zeros(len(x))
tab_som=np.zeros(len(x))
for k in range(len(x)):
    y[k]=ecart(exo4,x[k])
    tab_I[k]=point_milieu(exo3,x[k],1,100)
    tab_som[k]=y[k]+tab_I[k]
plt.plot(x,y)
plt.plot(x,tab_I)
plt.title('comparaison des courbes ecart et point milieu')
plt.show()

plt.plot(x,tab_som)
plt.title('Formule mixte en fonction de h')
plt.show()

print('somme init=',tab_som[1])
print('somme finale=',tab_som[-1])

I=ecart(exo4,0.01)+point_milieu(exo3,0.01,1,100)
print(I)

I=ecart(exo4,0.001)+point_milieu(exo3,0.001,1,1000)
print(I)

I=ecart(exo4,0.0001)+point_milieu(exo3,0.0001,1,10000)
print(I)

tab_I=np.zeros(10)
for k in range(10):
    tab_I[k]=ecart(exo4,10**(-k))+point_milieu(exo3,10**(-k),1,1000)
plt.plot(tab_I)
plt.show()

#print(tab_I[1])
print('Valeur optimale:',tab_I[2],'obtenue pour k=',2,'i.e: h=',10**(-2))
#print(tab_I[3])
    
    


  

    
